/*
 * pi - P user Interface
 * 
 * $Id: window.c,v 1.1 2001/02/05 15:51:07 malekith Exp $
 * Author: Michal Moskal <malekith@pld.org.pl>
 * include COPYING-GNU
 */

#include <pi/pi.h>
#include <string.h>

void pi_window_draw(struct pi_object *ctx)
{
	int n, x, y;
	char *title;
	
	pi_set_color(ctx, 0);
	pi_locate(ctx, &x, &y);
	pi_frame(x, y, ctx->w, ctx->h);

	pi_goto(x + 1, y + 1);

	pi_fill(' ', x + 1, y + 1, ctx->w - 2, ctx->h - 2);
	
	title = pi_ptr(caption);
	if ((n = strlen(title)) != 0) {
		n += 2;
		
		pi_set_color(ctx, 1);
		if (n > ctx->w - 2) {
			pi_goto(x + 1, y);
			pi_putch(' ');
			n = ctx->w - 7;
			if (n > 0)
				pi_addstrn(title, n);
			pi_addstr("... ");
		} else {
			pi_goto(x + (ctx->w - n) / 2, y);
			pi_putch(' ');
			pi_addstr(title);
			pi_putch(' ');
		}
	}
}

void pi_window_cc(struct pi_object *ctx, int cc)
{
	pi_set_tag(ctx, pi_tag_modal_result, cc);
}

struct pi_object *pi_new_window(struct pi_object *ctx, struct pi_object *super)
{
	const char *title;
	
	pi_new_init((0,
			pi_tag_flags, pi_f_can_get_focus,
			pi_tag_cc_handler, pi_window_cc,
			pi_tag_draw_handler, pi_window_draw,
			PI_COLOR(norm, cyan, black),
			PI_COLOR(norm_hl, lightgray, black),
			PI_COLOR(acct, lightcyan, black),
			PI_COLOR(acct_hl, white, black),
	0), object);

	title = pi_ptrd(caption, "");
	pi_set_tag(ret, pi_tag_caption | pi_tf_free, strdup(title));

	pi_init_size(ret, 0, 0, 20, 10);

	return ret;
}
